Deleted Added
full compact
usb.subr (252077) usb.subr (252721)
1if [ ! "$_MEDIA_USB_SUBR" ]; then _MEDIA_USB_SUBR=1
2#
3# Copyright (c) 2012-2013 Devin Teske
4# All Rights Reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
1if [ ! "$_MEDIA_USB_SUBR" ]; then _MEDIA_USB_SUBR=1
2#
3# Copyright (c) 2012-2013 Devin Teske
4# All Rights Reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: head/usr.sbin/bsdconfig/share/media/usb.subr 252077 2013-06-21 23:13:55Z dteske $
27# $FreeBSD: head/usr.sbin/bsdconfig/share/media/usb.subr 252721 2013-07-04 20:12:12Z dteske $
28#
29############################################################ INCLUDES
30
31BSDCFG_SHARE="/usr/share/bsdconfig"
32. $BSDCFG_SHARE/common.subr || exit 1
33f_dprintf "%s: loading includes..." media/usb.subr
34f_include $BSDCFG_SHARE/device.subr
35f_include $BSDCFG_SHARE/dialog.subr
36f_include $BSDCFG_SHARE/media/common.subr
37f_include $BSDCFG_SHARE/struct.subr
38f_include $BSDCFG_SHARE/variable.subr
39
40BSDCFG_LIBE="/usr/libexec/bsdconfig"
41f_include_lang $BSDCFG_LIBE/include/messages.subr
42
43############################################################ GLOBALS
44
45USB_MOUNTED=
46
47############################################################ FUNCTIONS
48
49# f_media_set_usb
50#
51# Attempt to use USB as the media type. Return success if we both found and set
52# the media type to be a USB drive.
53#
54f_media_set_usb()
55{
56 f_media_close
57
58 local devs ndevs
59 f_device_find "" $DEVICE_TYPE_USB devs
60 ndevs=$( set -- $devs; echo $# )
61
62 if [ ${ndevs:=0} -eq 0 ]; then
63 f_dialog_msgbox "$msg_no_usb_devices_found"
64 return $FAILURE
65 elif [ $ndevs -gt 1 ]; then
66 local title="$msg_choose_a_usb_drive"
67 local prompt="$msg_please_select_a_usb_drive"
68 local hline=""
69
70 local dev retval
71 dev=$( f_device_menu \
72 "$title" "$prompt" "$hline" $DEVICE_TYPE_USB \
73 2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD )
74 retval=$?
75 [ "$dev" ] || return $FAILURE
76
77 f_device_find "$dev" $DEVICE_TYPE_USB devs
78 [ "$devs" ] || return $FAILURE
79 dev="${devs%%[$IFS]*}"
80
81 f_struct_copy device_$dev device_media
82 [ $retval -eq $SUCCESS ] || return $FAILURE
83 else
84 f_struct_copy device_$devs device_media
85 fi
86
87 f_struct device_media &&
88 device_media unset private
89
90 if f_interactive; then
91 local name
92 f_struct device_media get name name
93 f_show_msg "$msg_using_usb_device" "$name"
94 fi
95
96 f_struct device_media || return $FAILURE
97}
98
99# f_media_init_usb $device
100#
101# Initializes the USB media device. Returns success if able to mount the USB
102# disk device using mount(8).
103#
104f_media_init_usb()
105{
106 local dev="$1" devname err
107
108 device_$dev get devname devname || return $FAILURE
109 f_dprintf "Init routine called for USB device. devname=[%s]" \
110 "$devname"
111
112 if [ "$USB_MOUNTED" ]; then
113 f_dprintf "USB device already mounted."
114 return $SUCCESS
115 fi
116
117 if [ ! -e "$MOUNTPOINT" ] &&
118 ! err=$( mkdir -p "$MOUNTPOINT" 2>&1 )
119 then
120 f_dialog_msgbox "$err"
121 return $FAILURE
122 fi
123
124 if err=$( mount "$devname" "$MOUNTPOINT" 2>&1 ); then
125 USB_MOUNTED=1
126 return $SUCCESS
127 fi
128
129 err="${err#mount: }"; err="${err#$devname: }"
130 f_show_msg "$msg_error_mounting_usb_drive" \
131 "$devname" "$MOUNTPOINT" "$err"
132 return $FAILURE
133}
134
135# f_media_get_usb $device $file [$probe_only]
136#
137# Returns data from $file on a mounted USB disk device. Similar to cat(1).
28#
29############################################################ INCLUDES
30
31BSDCFG_SHARE="/usr/share/bsdconfig"
32. $BSDCFG_SHARE/common.subr || exit 1
33f_dprintf "%s: loading includes..." media/usb.subr
34f_include $BSDCFG_SHARE/device.subr
35f_include $BSDCFG_SHARE/dialog.subr
36f_include $BSDCFG_SHARE/media/common.subr
37f_include $BSDCFG_SHARE/struct.subr
38f_include $BSDCFG_SHARE/variable.subr
39
40BSDCFG_LIBE="/usr/libexec/bsdconfig"
41f_include_lang $BSDCFG_LIBE/include/messages.subr
42
43############################################################ GLOBALS
44
45USB_MOUNTED=
46
47############################################################ FUNCTIONS
48
49# f_media_set_usb
50#
51# Attempt to use USB as the media type. Return success if we both found and set
52# the media type to be a USB drive.
53#
54f_media_set_usb()
55{
56 f_media_close
57
58 local devs ndevs
59 f_device_find "" $DEVICE_TYPE_USB devs
60 ndevs=$( set -- $devs; echo $# )
61
62 if [ ${ndevs:=0} -eq 0 ]; then
63 f_dialog_msgbox "$msg_no_usb_devices_found"
64 return $FAILURE
65 elif [ $ndevs -gt 1 ]; then
66 local title="$msg_choose_a_usb_drive"
67 local prompt="$msg_please_select_a_usb_drive"
68 local hline=""
69
70 local dev retval
71 dev=$( f_device_menu \
72 "$title" "$prompt" "$hline" $DEVICE_TYPE_USB \
73 2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD )
74 retval=$?
75 [ "$dev" ] || return $FAILURE
76
77 f_device_find "$dev" $DEVICE_TYPE_USB devs
78 [ "$devs" ] || return $FAILURE
79 dev="${devs%%[$IFS]*}"
80
81 f_struct_copy device_$dev device_media
82 [ $retval -eq $SUCCESS ] || return $FAILURE
83 else
84 f_struct_copy device_$devs device_media
85 fi
86
87 f_struct device_media &&
88 device_media unset private
89
90 if f_interactive; then
91 local name
92 f_struct device_media get name name
93 f_show_msg "$msg_using_usb_device" "$name"
94 fi
95
96 f_struct device_media || return $FAILURE
97}
98
99# f_media_init_usb $device
100#
101# Initializes the USB media device. Returns success if able to mount the USB
102# disk device using mount(8).
103#
104f_media_init_usb()
105{
106 local dev="$1" devname err
107
108 device_$dev get devname devname || return $FAILURE
109 f_dprintf "Init routine called for USB device. devname=[%s]" \
110 "$devname"
111
112 if [ "$USB_MOUNTED" ]; then
113 f_dprintf "USB device already mounted."
114 return $SUCCESS
115 fi
116
117 if [ ! -e "$MOUNTPOINT" ] &&
118 ! err=$( mkdir -p "$MOUNTPOINT" 2>&1 )
119 then
120 f_dialog_msgbox "$err"
121 return $FAILURE
122 fi
123
124 if err=$( mount "$devname" "$MOUNTPOINT" 2>&1 ); then
125 USB_MOUNTED=1
126 return $SUCCESS
127 fi
128
129 err="${err#mount: }"; err="${err#$devname: }"
130 f_show_msg "$msg_error_mounting_usb_drive" \
131 "$devname" "$MOUNTPOINT" "$err"
132 return $FAILURE
133}
134
135# f_media_get_usb $device $file [$probe_only]
136#
137# Returns data from $file on a mounted USB disk device. Similar to cat(1).
138# $probe_only is currently unused by this media type.
138# If $probe_only is present and non-NULL, returns success if $file exists.
139#
140f_media_get_usb()
141{
142 local dev="$1" file="$2" probe_only="$3"
143
144 f_dprintf "f_media_get_usb: dev=[%s] file=[%s] probe_only=%s" \
145 "$dev" "$file" "$probe_only"
146
139#
140f_media_get_usb()
141{
142 local dev="$1" file="$2" probe_only="$3"
143
144 f_dprintf "f_media_get_usb: dev=[%s] file=[%s] probe_only=%s" \
145 "$dev" "$file" "$probe_only"
146
147 f_media_generic_get "$MOUNTPOINT" "$file"
147 f_media_generic_get "$MOUNTPOINT" "$file" "$probe_only"
148}
149
150# f_media_shutdown_usb $device
151#
152# Shuts down the USB disk device using umount(8). Return status should be
153# ignored.
154#
155f_media_shutdown_usb()
156{
157 local dev="$1" err
158
159 [ "$USB_MOUNTED" ] || return
160
161 if ! err=$( umount -f "$MOUNTPOINT" 2>&1 ); then
162 err="${err#umount: }"; err="${err#*: }"
163 f_show_msg "$msg_could_not_unmount_the_ufs_partition" \
164 "$MOUNTPOINT" "$err"
165 else
166 USB_MOUNTED=
167 fi
168}
169
170############################################################ MAIN
171
172f_dprintf "%s: Successfully loaded." media/usb.subr
173
174fi # ! $_MEDIA_USB_SUBR
148}
149
150# f_media_shutdown_usb $device
151#
152# Shuts down the USB disk device using umount(8). Return status should be
153# ignored.
154#
155f_media_shutdown_usb()
156{
157 local dev="$1" err
158
159 [ "$USB_MOUNTED" ] || return
160
161 if ! err=$( umount -f "$MOUNTPOINT" 2>&1 ); then
162 err="${err#umount: }"; err="${err#*: }"
163 f_show_msg "$msg_could_not_unmount_the_ufs_partition" \
164 "$MOUNTPOINT" "$err"
165 else
166 USB_MOUNTED=
167 fi
168}
169
170############################################################ MAIN
171
172f_dprintf "%s: Successfully loaded." media/usb.subr
173
174fi # ! $_MEDIA_USB_SUBR